unit svcExample1;


interface

uses
    Windows,
    Messages,
    SysUtils,
    Classes,
    Graphics,
    Dialogs,
    Controls,
    WinSvc,
    SvCom_WinSvc,
    SvCom_NTService,
    ExtCtrls;

type
  TSampleService1 = class(TNTService)
    procedure SampleService1Start(Sender: TNtService;
      var DoAction: Boolean);
    procedure SampleService1Stop(Sender: TNtService;
      var DoAction: Boolean);
    procedure NtServiceAfterInstall(Sender: TObject);
    procedure NtServiceCustomControl(Sender: TNtService; ControlCode: Integer);
  private
    { Private declarations }
    Timer: TTimer;
    procedure TimerOnTimer(Sender: TObject);
  public
    { Public declarations }
  end;

var
  SampleService1: TSampleService1;

implementation

{$R *.DFM}


procedure TSampleService1.TimerOnTimer(Sender: TObject);
begin
    Beep;
end;

type _SERVICE_PRESHUTDOWN_INFO = record
  dwPreshutdownTimeout: DWORD;
end;
SERVICE_PRESHUTDOWN_INFO = _SERVICE_PRESHUTDOWN_INFO;
LPSERVICE_PRESHUTDOWN_INFO = ^_SERVICE_PRESHUTDOWN_INFO;
TsvServicePreshutdownInfo = _SERVICE_PRESHUTDOWN_INFO;


procedure TSampleService1.NtServiceAfterInstall(Sender: TObject);
var
  HService: SC_HANDLE;
  HManager: SC_HANDLE;
  PreshutdownInfo : TsvServicePreshutdownInfo;

begin

    HManager:= SvOpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);
    if HManager = 0 then RaiseLastWin32Error;

    HService := SvOpenService(HManager,PChar(ServiceName),SERVICE_ALL_ACCESS);
    if HService = 0 then RaiseLastWin32Error;

    PreshutdownInfo.dwPreshutdownTimeout := 1000 * 600; // Wait for TEN MINUTES!!!
    SvChangeServiceConfig2(HService, SERVICE_CONFIG_PRESHUTDOWN_INFO, @PreshutdownInfo);
    SvCloseServiceHandle(HService);
    SvCloseServiceHandle(HManager);
end;

procedure TSampleService1.NtServiceCustomControl(Sender: TNtService; ControlCode: Integer);
var StopTime: TDateTime;
  FS: TFileStream;
  S: String;
begin
  if ControlCode = SERVICE_CONTROL_PRESHUTDOWN then
  begin
    ForceDirectories('C:\Temp');
    CurrentStatus:=csStopPending;
    StopTime := Now + 300./24/3600;
    while Now < StopTime do
    begin
      ReportStatus;

      FS := TFileStream.Create('C:\Temp\'+FormatDateTime('yyyy-mm-dd-hh-nn-ss',now)+'.txt',fmCreate);
      S := 'Preshutdown is in progress';
      FS.Write(S[1], Length(S)*SizeOf(S[1]));
      FS.Free;
      Sleep(3000);

    end;
    CurrentStatus:=csStopped;
  end;
end;

procedure TSampleService1.SampleService1Start(Sender: TNtService;
  var DoAction: Boolean);
begin
    Timer:=TTimer.Create(nil);
    Timer.OnTimer:=TimerOnTimer;
end;

procedure TSampleService1.SampleService1Stop(Sender: TNtService;
  var DoAction: Boolean);
begin
    Timer.Free;
    Timer:=nil;
end;

end.

